#encoding: utf-8
#***********copyright********************
#*The source codes are sole and exclusive property of Wondershare.
#*The source codes are confidential information of Wondershare.
#*Unauthorised access, disclosure, use or copying of the source codes is strictly prohibited and may be #unlawful.
#************confidential*******************
from __future__ import unicode_literals
import re
import sys 
import threading
import time

from ..extractor.common import InfoExtractor
from ..utils import (
    urlencode_postdata,
    sanitized_Request,
    update_url_query,
    smuggle_url,
    unsmuggle_url,
    ExtractorError,
    xpath_text,
    url_or_none,
    int_or_none,
    determine_ext
)
from ..compat import (
    compat_urllib_parse_urlparse,
    compat_b64decode,
    compat_parse_qs,
    compat_xpath
)
from ..utilsEX import JSInterpreter, downloadWebPage_BYHeadlessBrowser_withJS, downloadWebPage_BYHeadlessBrowser, downloadWebPage_BYHeadlessBrowser_localFile

class financialsecurityIE(InfoExtractor):    
    _VALID_URL = r'https?://(?:.+\.)?financialsecurity\.video/'

    def _real_extract(self, url):
        print('SockShare begin') 
        video_id = self._search_regex(r'\.video/147([^\?]+)', url, url)
        webpage = self._download_webpage(url, 'financialsecurity') 
        title = self._search_regex('title>(.+)</title', webpage, webpage)
        query_url = 'https://financialsecurity.video/manifest/%d/%s' % (int(time.time()*1000), video_id)
        json_data = self._download_json(query_url, query_url)
        mainfest_url = json_data['url']
        formats = self._extract_m3u8_formats(mainfest_url, video_id, ext='mp4', m3u8_id='hls')
        for f in formats:
            if f['vcodec'] == 'none':
                f['format_note'] = 'DASH audio'
            
        return {
            'id': video_id,
            'formats': formats,
            'title': title,
        }


        