#encoding: utf-8
#***********copyright********************
#*The source codes are sole and exclusive property of Wondershare.
#*The source codes are confidential information of Wondershare.
#*Unauthorised access, disclosure, use or copying of the source codes is strictly prohibited and may be #unlawful.
#************confidential*******************
from __future__ import unicode_literals
import re
import json
from ..utils import compat_str,determine_ext
from ..extractor.fox import FOXIE as Old, try_get
from ..utilsEX import download_webPage_by_PYCURL
import uuid
class FoxIE(Old):
    def _download_webpage(self, url_or_request, video_id, note=None, errnote=None, fatal=True, tries=1, timeout=5, encoding=None, data=None, headers={}, query={}):
        try:
            return super(FoxIE, self)._download_webpage(url_or_request, video_id, note, errnote, fatal, tries, timeout, encoding, data, headers, query)
        except:
            return download_webPage_by_PYCURL(self, url_or_request, timeout, data, headers, query)

    def _real_extract(self, url):
        try:
            result = super(FoxIE, self)._real_extract(url)
            if not result:
                raise Exception('ori parser fail')
            return result
        except Exception as ex:
            video_id = self._match_id(url)
            headers = {'x-api-key': 'abdcbed02c124d393b39e818a4312055','Content-Type': 'application/json', 'Referer': url}
            device_id = compat_str(uuid.uuid4())
            data = self._download_json('https://api2.fox.com/v2.0/previewpassmvpd?device_id=' + device_id + '&mvpd_id=TempPass_fbcfox_60min', video_id, headers=headers)
            headers['Authorization'] = 'Bearer ' + data['accessToken']
            video = self._download_json('https://api2.fox.com/v2.0/vodplayer/'+ video_id + '?sitesection=app.dcg-foxnow%252Fweb%252Ffox', video_id, headers=headers)
            if not 'url' in video:
                return

            data = self._download_json(video['url'], '')
            source_type = determine_ext(data['playURL'])
            formats = []
            if source_type == 'm3u8':
                formats.extend(self._extract_m3u8_formats(
                    data['playURL'], video_id, 'mp4',
                    m3u8_id='hls', fatal=False))
            else:
                formats.append({
                    'url': data['playURL'],
                })

            return {
                'id': video_id,
                'title': video['name'],
                'formats': formats,
            }
