# encoding: utf-8
#***********copyright********************
#*The source codes are sole and exclusive property of Wondershare.
#*The source codes are confidential information of Wondershare.
#*Unauthorised access, disclosure, use or copying of the source codes is strictly prohibited and may be #unlawful.
#************confidential*******************
from __future__ import unicode_literals

import tempfile
import os
import io
import sys
import re
import json
from ..extractor.instagram import InstagramIE as OldIe

class instagramIE(OldIe):
    _VALID_URL = r'(?P<url>https?://(?:www\.)?instagram\.com/(?:p|tv|reel)/(?P<id>[^/?#&]+))'

    def _real_extract(self, url):
        try:
            return super(instagramIE, self)._real_extract(url)
        except:
            mobj = re.match(self._VALID_URL, url)
            video_id = mobj.group('id')            
            html = self._download_webpage(url, url)
            data = re.search('>window.__additionalDataLoaded\(\'\/p\/%s/\',({.+)\);<\/script>' % video_id, html)
            info = json.loads(data.group(1))
            
            shortcode_media = info['graphql']['shortcode_media']
            if 'edge_sidecar_to_children' in shortcode_media:
                edges = shortcode_media['edge_sidecar_to_children']['edges']
                for edge in edges:
                    title = edge['node']['shortcode']
                    if 'video_url' in edge['node']:
                        formats = [{
                            'url': edge['node']['video_url'],
                        }]
                        return {
                            'id': video_id,
                            'formats': formats,
                            'ext': 'mp4',
                            'title': title
                        }  
            else:   
                       
                formats = [{
                            'url': shortcode_media['video_url']  ,
                }]     
                return {
                    'id': video_id,
                    'formats': formats,
                    'ext': 'mp4',
                    'title': video_id
                }                                   