#***********copyright********************
#*The source codes are sole and exclusive property of Wondershare.
#*The source codes are confidential information of Wondershare.
#*Unauthorised access, disclosure, use or copying of the source codes is strictly prohibited and may be #unlawful.
#************confidential*******************
from __future__ import unicode_literals
import json
import base64
import re
from ..extractor.common import InfoExtractor
from ..utils import qualities
from ..utilsEX import downloadWebPage_BYHeadlessBrowser_localFile, downloadWebPage_BYHeadlessBrowser, downloadWebPage_BYHeadlessBrowser_withJS

class iXiGuaIE(InfoExtractor):
    _VALID_URL = r'https?://(?:www\.)?ixigua\.com'

    _TEST = {
        'url': 'https://www.ixigua.com/6941436307453248011?logTag=J9QlfKI9NUf533XWhx9zr&wid_try=1',
    }
          

    def _extractNormal(self, video_list):
        formats = []
        for key in video_list.keys(): 
            videoUrl= video_list[key]           
            get_quality = qualities(['360p', '480p', '720p', '1080p'])
            formats.append({
                'quality': get_quality(key),
                'url': videoUrl,
                'ext': 'mp4'
            })                               
        return formats  

    def _real_extract(self, url):
        js = '''
videos = _SSR_HYDRATED_DATA['anyVideo']['gidInformation']['packerData']['video']['videoResource'];

vformats = {
};

video_list = videos['normal']['video_list'];

for (key in video_list){
    vformats[video_list[key]['definition']] = 'https:' + video_list[key]['main_url'];
}

function output(n){
            if(window.external){
                window.external.output('<MyManifest>' + n + '</MyManifest>');
            }else{
                window.WebViewJavascriptBridge.callHandler('JSSendToOC','<MyManifest>' + n + '</MyManifest>');
            }
}
mydata = {'123':'456'};
mydata['title'] = window.btoa(unescape(encodeURIComponent(_SSR_HYDRATED_DATA['anyVideo']['gidInformation']['packerData']['video']['title'])));
mydata['normal'] = vformats;
result = output(JSON.stringify(mydata));      
'''
        webpage = downloadWebPage_BYHeadlessBrowser_withJS(url, js, waitTime=10)
        sxt = self._search_regex(r'<MyManifest>([\s\S]+)<\/MyManifest>', webpage, 'json')
        jsonData = json.loads(sxt) 
        if 'normal' in jsonData:
            formats = self._extractNormal(jsonData['normal'])
        title =  base64.b64decode(jsonData['title'].encode()).decode('utf-8')
                    
        return {
            '_type': 'video',
            'id': 'x',
            'title':title,
            'formats': formats,
        }
