# encoding: utf-8
#***********copyright********************
#*The source codes are sole and exclusive property of Wondershare.
#*The source codes are confidential information of Wondershare.
#*Unauthorised access, disclosure, use or copying of the source codes is strictly prohibited and may be #unlawful.
#************confidential*******************
from __future__ import unicode_literals

import re
import json

from ..extractor.common import (
    InfoExtractor,
)

from ..utils import (
    int_or_none,
    ExtractorError,
    qualities
)

from ..utilsEX import downloadWebPage_BYHeadlessBrowser_localFile

class xinxindmEpisodesIE(InfoExtractor):
    #https://edu.51cto.com/course/21671.html
    #https://www.xinxindm.com/nr/rerenzaoren009/
    _VALID_URL = r'https?://(?:www\.)xinxindm.com/[^\/]+/.+(?!\.htm)'

    def _real_extract(self, url):
        episodeID = '123'

        webpage = self._download_webpage(url, url)
        title = self._html_search_regex(r'<title>(.+)</title>', webpage, 'video title')
        playlistContent = self._search_regex(r'id\=\"con_playlist_1\">([\s\S]+?)</ul>', webpage, '')
        episodes = re.findall(r'href="(.+)">(.+)</a', playlistContent)
        entries = []
        for index, episode in enumerate(episodes):
            entries.append({'id': str(index), 'title': episode[1], 'url': 'https://www.xinxindm.com'+ episode[0]})
        self.to_screen('xinxindmEpisodes 6')
        return self.playlist_result(entries, episodeID, title)       


class xinxindmIE(InfoExtractor):
    _VALID_URL = r'https?://(?:www\.)xinxindm.com/[^\/]+/.+\.htm'


    def _real_extract(self, url):
        webpage = self._download_webpage(url, url)
        title = self._html_search_regex(r'<title>(.+?)</title>', webpage, 'title').strip()        
        data = self._search_regex(r'cms_player\s*\=\s*(\{.+\});', webpage, '')    
        jData = json.loads(data)
        video_url = jData['url']
        if video_url.startswith('http'):
            formats = [
                {
                    'url': video_url,
                    'ext': 'mp4'
                }
            ]
        else:
            id = video_url
            init_url = "https://video.shenduoduo.cc/?vcode=%s&autoPlay=true&inFrame=true" % id
            webpage2 = self._download_webpage(init_url,'', headers={'Referer': 'https://www.xinxindm.com'}) 
            requestId = self._search_regex(r'null,"","([^"]+)', webpage2, '')
            queryURL = "https://video.shenduoduo.cc/vod/within/playaddr/get?vcode=%s&requestId=%s" % (id,requestId)
            jsonData = self._download_json(queryURL, '', headers={'Request-URL': 'www.xinxindm.com'})
            video_url = 'https://video.shenduoduo.cc/vod' + jsonData['data']['playAddr'][0]['addr']
            formats = [
                {
                    'url': video_url,
                    'protocol': 'm3u8' if video_url.find('m3u8')>-1 else 'http',
                    'http_headers': {
                        'Referer': init_url
                    }
                }
            ]
                    
        self._sort_formats(formats)
        return {
            'id': '123',
            'title': title,
            'formats': formats
        }